
#include <avr/pgmspace.h>

#define DATAOUT 11//MOSI
#define DATAIN  12//MISO 
#define SPICLOCK  13//sck
#define SLAVESELECT 10//ss

#define GET_FW_VERSION 0x26
#define RESET 0x24


#include "WProgram.h"
void setup();
void loop();
void select();
void deselect();
char spi_transfer(volatile char data);
char fw_array[36];
char in_byte = 0;
char clr = 0;
char count = 0;

void setup()
{
  Serial.begin(9600);

  pinMode(DATAOUT, OUTPUT);
  pinMode(DATAIN, INPUT);
  digitalWrite(DATAIN,LOW);
  pinMode(SPICLOCK,OUTPUT);
  pinMode(SLAVESELECT,OUTPUT);
  digitalWrite(SLAVESELECT,HIGH); //disable device 

  Serial.begin(9600);
  Serial.println("Kent LCD Test");
  
}

void loop()
{
  // SPCR = 01010000
  //interrupt disabled,spi enabled,msb 1st,master,clk low when idle,
  //sample on leading edge of clk,system clock/4 rate (fastest)
  SPCR = (1<<SPE) | (1<<MSTR) | (1<<SPR0) | (1<<CPHA);
  clr=SPSR;
  clr=SPDR;
  
  for(int i = 0x00; i < 0x25; i+=0x01){
    select();
    spi_transfer(0x00); // TX command
    spi_transfer(i); // Address
    spi_transfer(0x00);
    for(int j = 0; j < 256; j++){ // Data
      if(j%2) { spi_transfer(0xFF); }
      else{ spi_transfer(0x00); }
    }
    deselect();
    delay(5);
  }
  select();
  spi_transfer(0x00);
  spi_transfer(0x25);
  spi_transfer(0x00);
  for(int j = 0; j < 128; j++){
    spi_transfer(0x00);
  }
  deselect();
  delay(5);
  
  Serial.println("Data transfer complete.");
  
  select(); // Screen update
  spi_transfer(0x18);
  spi_transfer(0x00);
  spi_transfer(0x00);
  deselect();
  
  Serial.println("Screen update complete.");
  
  while(1);


}

void select() {
  digitalWrite(SLAVESELECT,LOW);
}

void deselect() {
  digitalWrite(SLAVESELECT,HIGH);
}

char spi_transfer(volatile char data)
{
  SPDR = data;                    // Start the transmission
  while (!(SPSR & (1<<SPIF)))     // Wait for the end of the transmission
  {
  };
  return SPDR;                    // return the received byte
}



int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

